/* Startup Code -V */
#include <stdint.h>

void __attribute__((section(".start"))) Startup(void)
{
	extern char _sbss, _ebss, _stack;
	extern int main();

	/* set stack pointer */
	__asm__ volatile ("mv sp, %0\n\r" : : "r"(&_stack));

	/* clear .bss */
	uint32_t len = &_ebss - &_sbss;
	char*    p   = &_sbss;
	while(len--) *p++ = (char)0;

	/* call main */
	main();

	/* run invalid opcode to trap */
	__asm__ __volatile__ (".byte 0x00, 0x00, 0x00, 0x00");
	while(1);
}

